Unit IDS7R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure IDS7R(N :Integer; var X :Array of Real;
                var Y :Array of Real; var Y1 :Array of Real;
                var Y2 :Array of Real; var Y3 :Array of Real);

implementation

procedure IDS7R(N :Integer; var X :Array of Real;
                var Y :Array of Real; var Y1 :Array of Real;
                var Y2 :Array of Real; var Y3 :Array of Real);
var
N1,K,J1,J2,N2 :Integer;
D1,D2,U1,U2,V1,V2,S1,S2,T1,T2,Z,R :Real;
label
_1,_2,_3,_4,_5,_6;
begin
N1 := N-1;
D1 := 0.5*Y2[0];
D2 := 0.5*Y2[N-1];
Y2[0] := 0.0;
Y3[0] := 0.0;
for K:=1 to N1 do
 begin
  J2 := K+1;
  U2 := 1.0/(X[J2-1]-X[K-1]);
  V2 := U2*U2;
  S2 := 10.0*U2*V2*(Y[J2-1]-Y[K-1]);
  T2 := 4.0*V2*(Y1[J2-1]+Y1[K-1]);
  if ( K = 1 ) 
   then goto _1;
  Z := 1.0/(3.0*(U1+U2)+U1*Y2[J1-1]);
  Y2[K-1] := -Z*U2;
  R := (S2-S1)-(T2-T1)+2.0*(V1-V2)*Y1[K-1];
  if ( K = 2 ) 
   then R := R+U1*D1;
  if ( K = N1 ) 
   then R := R+U2*D2;
  Y3[K-1] := Z*(R+U1*Y3[J1-1]);
_1:
  J1 := K;
  U1 := U2;
  V1 := V2;
  S1 := S2;
  T1 := T2;
_2:
 end;
Y2[N1-1] := Y3[N1-1];
if ( N1 <= 2 ) 
 then goto _4;
N2 := N1-1;
for J1:=2 to N2 do
 begin
  K := N-J1;
  Y2[K-1] := Y3[K-1]-Y2[K-1]*Y2[K+0];
_3:
 end;
_4:
Y2[0] := 2.0*D1;
for K:=2 to N1 do
 begin
_5:
  Y2[K-1] := 2.0*Y2[K-1];
 end;
for K:=2 to N do
 begin
  U1 := X[K-1]-X[K-2];
  U2 := 1.0/U1;
  V1 := U2*U2;
  R := 20.0*(Y[K-1]-Y[K-2])*U2-12.0*Y1[K-2]-8.0*Y1[K-1];
_6:
  Y3[K-2] := 3.0*V1*(R+U1*(Y2[K-1]-Y2[K-2]*3.0));
 end;
U1 := X[N-1]-X[N-2];
U2 := 1.0/U1;
V1 := U2*U2;
S1 := 6.0*(Y[N-1]-Y[N-2])*U2-3.0*(Y1[N-2]+Y1[N-1])+0.5*U1*
    (Y2[N-1]-Y2[N-2]);
S2 := 8.0*Y1[N-2]+7.0*Y1[N-1]-15.0*(Y[N-1]-Y[N-2])*U2+0.5*U1*
    (3.0*Y2[N-2]-2.0*Y2[N-1]);
Y3[N-1] := (60.0*S1+24.0*S2)*V1+Y3[N-2];
end;

end.
